## cppad 2019.02.00.1

=== CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# =============================================================================
# Some constants
# =============================================================================
# Suppress warnging that WIN32 not defined on cygwin
SET(CMAKE_LEGACY_CYGWIN_WIN32 0) # remove when version below >= 2.8.4
#
# Set the minimum required version of cmake for this project.
# see http://www.cmake.org/pipermail/cmake/2013-January/053213.html
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.4)
#
# https://gitlab.kitware.com/cmake/cmake/issues/17292
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()
#
# cppad_version is used by version.sh to get the version number.
SET(cppad_version "20190200.1")
SET(cppad_url          "http://www.coin-or.org/CppAD" )
SET(cppad_description  "Differentiation of C++ Algorithms" )
#
# Set name of this project and create the variables
# cppad_BINARY_DIR and cppad_SOURCE_DIR.
# project(projectname [CXX] [C] [Java])
PROJECT(cppad)
#
# Add the include sub-directory to the list of C++ preprocessor
# include directories for the entire project.
# include_directories([AFTER|BEFORE] [SYSTEM] dir1 dir2 ...)
INCLUDE_DIRECTORIES( ${cppad_SOURCE_DIR}/include )
#
# =============================================================================
# Some system cmake language extensions
# =============================================================================
# CHECK_CXX_SOURCE_COMPILES(source variable)
# Checks whether the code given in source will compile, link and run and
# return zero status. You can set
# CMAKE_REQUIRED_LIBRARIES, CMAKE_REQUIRED_FLAGS and CMAKE_REQUIRED_INCLUDES
# accordingly if additional libraries or compiler flags are required.
INCLUDE(CheckCXXSourceRuns)

# ============================================================================
# Some local cmake language
# ============================================================================
# join strings together
INCLUDE(cmake/join.cmake)
#
# dos_path_to_unix(dos_path unix_path)
INCLUDE(cmake/dos_path_to_unix.cmake)
#
# add_to_list(variable_list constant_value)
INCLUDE(cmake/add_to_list.cmake)
#
# command_line_arg(variable default type description)
INCLUDE(cmake/command_line_arg.cmake)
#
# optional_package(package description)
INCLUDE(cmake/optional_package.cmake)
#
# check_source_runs(source variable)
INCLUDE(cmake/check_source_runs.cmake)
#
# assert(variable)
INCLUDE(cmake/assert.cmake)
#
# print_variable(variable)
INCLUDE(cmake/print_variable.cmake)
#
# set_compile_flags( program_name debug_which source_list)
INCLUDE(cmake/set_compile_flags.cmake)
# =============================================================================
# command line arguments
# =============================================================================
# cmake_install_datadir
command_line_arg(cmake_install_datadir share STRING
    "directory, below prefix, where cmake installs cppad data files"
)
# -----------------------------------------------------------------------------
# cmake_install_docdir
command_line_arg(cmake_install_docdir NOTFOUND STRING
    "directory, below prefix, where cmake installs cppad documentation files"
)
# -----------------------------------------------------------------------------
# cmake_install_includedirs
command_line_arg(cmake_install_includedirs include STRING
    "directories, below prefix, where cmake installs include files"
)
# -----------------------------------------------------------------------------
# cmake_install_libdirs
command_line_arg(cmake_install_libdirs lib STRING
    "directories, below prefix, where cmake installs library files"
)
# -----------------------------------------------------------------------------
# cppad_prefix
command_line_arg(cppad_prefix /usr PATH
    "cppad install prefix"
)
SET(CMAKE_INSTALL_PREFIX "${cppad_prefix}"
    CACHE PATH "value copied from cppad_prefix" FORCE
)
IF( cmake_install_prefix )
    MESSAGE(FATAL_ERROR
        "cmake_install_prefix has been changed to cppad_prefix"
    )
ENDIF( cmake_install_prefix )
# -----------------------------------------------------------------------------
# cppad_postfix
command_line_arg(cppad_postfix NOTFOUND STRING
    "cppad install postfix"
)
IF( cmake_install_postfix )
    MESSAGE(FATAL_ERROR
        "cmake_install_postfix has been changed to cppad_postfix"
    )
ENDIF( cmake_install_postfix )
# -----------------------------------------------------------------------------
# cppad_cxx_flags
command_line_arg(cppad_cxx_flags "" STRING
    "compile flags used with cppad (besides debug, release, and profile flags)"
)
# -----------------------------------------------------------------------------
# cppad_profile_flag
command_line_arg(cppad_profile_flag NOTFOUND STRING
    "compile flag used to compile and link a profile version of a program"
)
# -----------------------------------------------------------------------------
# All the External package prefixes without warnings
SET(system_include TRUE)
#
# adolc_prefix
optional_package(adolc ${system_include} "adolc install prefix")
#
# colpack_prefix
optional_package(colpack ${system_include} "colpack install prefix")
#
# ipopt_prefix
optional_package(ipopt ${system_include} "ipopt install prefix")
#
# sacado_prefix
optional_package(sacado ${system_include} "sacado install prefix")
#
# eigen_prefix
optional_package(eigen ${system_include} "eigen install prefix")
#
# fadbad_prefix
optional_package(fadbad ${system_include} "fadbad install prefix")
# -----------------------------------------------------------------------------
# cppad_testvector
command_line_arg(cppad_testvector cppad STRING
    "Namespace of vector used for testing, one of: boost, cppad, eigen, std"
)
#
# cppad_max_num_threads
command_line_arg(cppad_max_num_threads 48 STRING
    "maximum number of threads that CppAD can use use"
)
# cppad_sparse_list
IF( cppad_sparse_list )
    MESSAGE(FATAL_ERROR
        "cppad_sparse_list = ${cppad_sparse_list}"
        ": this command line argument has been removed"
    )
ENDIF( cppad_sparse_list )
#
# cppad_tape_id_type
command_line_arg(cppad_tape_id_type "unsigned int" STRING
    "type used to identify different tapes, size must be <= sizeof(size_t)"
)
#
# cppad_tape_addr_type
command_line_arg(cppad_tape_addr_type "unsigned int" STRING
"type used to identify variables on one tape, size must be <= sizeof(size_t)"
)
#
# cppad_debug_which
command_line_arg(cppad_debug_which "debug_all" STRING
    "debug_even, debug_odd, debug_all, or debug_none"
)
# cppad_deprecated
IF( cppad_deprecated )
    MESSAGE(FATAL_ERROR "cppad_deprecated has been removed" )
ENDIF( cppad_deprecated )
# =============================================================================
# colpack_libs, cppad_lib
#
IF( cppad_has_colpack )
    SET( colpack_libs "ColPack" )
    SET( cppad_lib    "cppad_lib" )
ELSE( cppad_has_colpack )
    SET( colpack_libs "" )
    SET( cppad_lib    "" )
ENDIF( cppad_has_colpack )
# =============================================================================
# automated system configuration
# =============================================================================
# CMAKE_CXX_FLAGS
# remove Visual Studio C++ warning level if specified in cppad_cxx_flags
IF ( cppad_cxx_flags MATCHES "/W[0-9]" )
    STRING( REGEX REPLACE "/W[0-9]" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS} )
ENDIF ( cppad_cxx_flags MATCHES "/W[0-9]" )
print_variable(CMAKE_CXX_FLAGS)
# -----------------------------------------------------------------------------
# cppad_abs_includedir, cppad_abs_libdir, cppad_abs_datadir, cppad_abs_docdir
#
# for dir_types = includedirs, libdirs, datadir, docdir
FOREACH(dir_types includedirs libdirs datadir docdir)
    # set dir_type = dir_types with  "dirs" -> "dir"
    STRING(REGEX REPLACE "dirs" "dir" dir_type ${dir_types})
    #
    # set dir_name to first directory in cmake_install_${dir_types}
    SET(dir_name NOTFOUND)
    FOREACH(dir ${cmake_install_${dir_types}})
        IF( NOT dir_name )
            SET(dir_name ${dir})
        ENDIF( NOT dir_name )
    ENDFOREACH(dir ${cmake_install_${dir_types}})
    #
    # set cppad_abs_${dir_type}
    SET(cppad_abs_${dir_type} "${cppad_prefix}/${dir_name}" )
    #
    # check if we need to add a postfix to it
    IF( cppad_postfix )
        SET(cppad_abs_${dir_type} ${cppad_abs_${dir_type}}/${cppad_postfix} )
    ENDIF( cppad_postfix )
ENDFOREACH(dir_types includedirs libdirs datadir docdir)
# -----------------------------------------------------------------------------
# OPENMP_FOUND, OpenMP_CXX_FLAGS
FIND_PACKAGE(OpenMP)
# -----------------------------------------------------------------------------
# boost_prefix
FIND_PACKAGE(Boost)
SET(cppad_has_boost 0)
IF ( Boost_FOUND )
    SET(cppad_has_boost 1)
    #
    # Extract the Boost prefix from Boost_INCLUDE_DIRS
    #
    # convert to using unix directory separator
    dos_path_to_unix("${Boost_INCLUDE_DIRS}" boost_include_dirs)
    #
    # convert to just one directory
    STRING(REGEX REPLACE
        "([^ ]+).*" "\\1"
        boost_include_dir "${boost_include_dirs}"
    )
    #
    # extract part before last backslash
    STRING(REGEX REPLACE
        "([^ ]*)/[^/ ]*" "\\1"
        boost_prefix "${boost_include_dir}"
    )
    print_variable(boost_prefix)
    #
    # add boost include directories
    FOREACH(dir ${cmake_install_includedirs})
        IF( IS_DIRECTORY ${boost_prefix}/${dir} )
            INCLUDE_DIRECTORIES( ${boost_prefix}/${dir} )
            MESSAGE(STATUS "Found ${boost_prefix}/${dir}")
        ENDIF( IS_DIRECTORY ${boost_prefix}/${dir} )
    ENDFOREACH( dir )
    #
    # add boost link directories
    FOREACH(dir ${cmake_install_libdirs})
        IF( IS_DIRECTORY ${boost_prefix}/${dir} )
            LINK_DIRECTORIES( ${boost_prefix}/${dir} )
            MESSAGE(STATUS "Found ${boost_prefix}/${dir}")
        ENDIF( IS_DIRECTORY ${boost_prefix}/${dir} )
    ENDFOREACH( dir )
ENDIF ( Boost_FOUND )
# -----------------------------------------------------------------------------
# ipopt_LIBRARIES and ipopt_LIBRARY_DIRS
IF( cppad_has_ipopt )
    FIND_PACKAGE(PkgConfig)
    IF( NOT PKG_CONFIG_FOUND )
        MESSAGE(FATAL_ERROR "Using ipopt_prefix but cannot find pkg-config")
    ENDIF( NOT PKG_CONFIG_FOUND )
    #
    # Set the system environment variable PKG_CONFIG_PATH
    FOREACH(dir ${cmake_install_libdirs})
        IF(EXISTS "${ipopt_prefix}/${dir}/pkgconfig/ipopt.pc")
            SET( ENV{PKG_CONFIG_PATH} ${ipopt_prefix}/${dir}/pkgconfig )
        ENDIF(EXISTS "${ipopt_prefix}/${dir}/pkgconfig/ipopt.pc")
    ENDFOREACH(dir)
    #
    # pkg_check_modules(<PREFIX> [REQUIRED] <MODULE> [<MODULE>]*)
    # ipopt_LIBRARIES      ... only the libraries (w/o the '-l')
    # ipopt_LIBRARY_DIRS   ... the paths of the libraries (w/o the '-L')
    pkg_check_modules(ipopt ipopt)
    IF( NOT ipopt_FOUND )
        MESSAGE(FATAL_ERROR
"For all directories dir in cmake_install_libdirs, cannot find the file
    ipopt_prefix/dir/pkgconfig/ipopt.pc
where
    ipopt_prefix = ${ipopt_prefix}
    cmake_install_libdirs = ${cmake_install_libdirs}
"
        )
    ENDIF( NOT ipopt_FOUND )
ENDIF( cppad_has_ipopt )
# =============================================================================
# Currently building tests as normal executables
# =============================================================================
# The CMakeLists.txt file in the specified source directory is processed

=== example/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the example directory tests
# Inherit environment from ../CMakeList.txt

# initialize check_depends
SET(check_example_depends "")

# abs_normal examples
ADD_SUBDIRECTORY(abs_normal)

# atomic examples
ADD_SUBDIRECTORY(atomic_two)
ADD_SUBDIRECTORY(atomic_three)

# checkpoint exmaples
ADD_SUBDIRECTORY(chkpoint_two)

# general examples
ADD_SUBDIRECTORY(general)

# get_started
ADD_SUBDIRECTORY(get_started)

# ipopt_solve examples
IF( cppad_has_ipopt)
    ADD_SUBDIRECTORY(ipopt_solve)
ENDIF( cppad_has_ipopt)

# multi_thread examples
ADD_SUBDIRECTORY(multi_thread)

# optimize examples
ADD_SUBDIRECTORY(optimize)

# print_for example
ADD_SUBDIRECTORY(print_for)

# sparse examples
ADD_SUBDIRECTORY(sparse)

# utility examples
ADD_SUBDIRECTORY(utility)

# Add the check_example target
ADD_CUSTOM_TARGET(check_example "" DEPENDS ${check_example_depends})
MESSAGE(STATUS "make check_example: available")

# Change check depends in parent environment
add_to_list(check_depends check_example)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== speed/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------

# Initialize list of tests as empty
SET(check_speed_depends "")

# The CMakeLists.txt file in the specified source directory is processed
# before the current input file continues beyond this command.
# add_subdirectory(source_dir [binary_dir] [EXCLUDE_FROM_ALL])
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(cppad)
ADD_SUBDIRECTORY(double)
ADD_SUBDIRECTORY(example)
IF ( cppad_profile_flag )
    ADD_SUBDIRECTORY(profile)
ENDIF ( cppad_profile_flag )
#
IF( cppad_has_adolc )
    ADD_SUBDIRECTORY(adolc)
ENDIF( cppad_has_adolc )
IF( cppad_has_fadbad )
    ADD_SUBDIRECTORY(fadbad)
ENDIF( cppad_has_fadbad )
IF( cppad_has_sacado )
    ADD_SUBDIRECTORY(sacado)
ENDIF( cppad_has_sacado )

# check_speed
ADD_CUSTOM_TARGET(check_speed DEPENDS ${check_speed_depends} )
MESSAGE(STATUS "make check_speed: available")

# Change check depends in parent environment
add_to_list(check_depends check_speed)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== test_more/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the test_more directory tests

# initialize check_depends
SET(check_test_more_depends "")

# deprecated tests
ADD_SUBDIRECTORY(deprecated)

# compare_c tests
ADD_SUBDIRECTORY(compare_c)

# debug_rel tests
ADD_SUBDIRECTORY(debug_rel)

# cppad_for_tmb tests
IF( OPENMP_FOUND )
    ADD_SUBDIRECTORY(cppad_for_tmb)
ENDIF( OPENMP_FOUND )

# general tests
ADD_SUBDIRECTORY(general)

# Add the check_example target
ADD_CUSTOM_TARGET(check_test_more "" DEPENDS ${check_test_more_depends})
MESSAGE(STATUS "make check_test_more: available")

# Change check depends in parent environment
add_to_list(check_depends check_test_more)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== cppad_ipopt/speed/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the cppad_ipopt/speed directory tests
# Inherit build type from ../CMakeList.txt

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# Local link directories to search (not in external packages)
# (cannot use ../src/cppad_ipopt library because it is linke with debugging)
LINK_DIRECTORIES( ${ipopt_LIBRARY_DIRS} )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
# Include source for cppad_ipopt library so we build it without debugging
SET(source_list
    speed.cpp
    ../src/cppad_ipopt_nlp.cpp
    ../src/fun_record.hpp
    ../src/hes_fg_map.cpp
    ../src/jac_g_map.cpp
    ../src/sparse_map2vec.cpp
    ../src/vec_fun_pattern.cpp
    ode_speed.cpp
)
set_compile_flags( cppad_ipopt_example "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( cppad_ipopt_speed EXCLUDE_FROM_ALL ${source_list} )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(
    cppad_ipopt_speed
    cppad_ipopt
    ${cppad_lib}
    ${ipopt_LIBRARIES}
    ${colpack_libs}
)

# Add the check_cppad_ipopt_speed target
ADD_CUSTOM_TARGET(check_cppad_ipopt_speed
    cppad_ipopt_speed
    DEPENDS cppad_ipopt_speed cppad_ipopt
)
MESSAGE(STATUS "make check_cppad_ipopt_speed: available")

# Change check depends in parent environment
add_to_list(check_cppad_ipopt_depends check_cppad_ipopt_speed)
SET(check_cppad_ipopt_depends "${check_cppad_ipopt_depends}" PARENT_SCOPE)

=== cppad_ipopt/src/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the cppad_ipopt/src library
# Inherit build type from ../CMakeList.txt

#  add_library(<name> [STATIC | SHARED | MODULE] [EXCLUDE_FROM_ALL]
#   source1 source2 ... sourceN)
# )
SET(source_list
    cppad_ipopt_nlp.cpp
    hes_fg_map.cpp
    jac_g_map.cpp
    sparse_map2vec.cpp
    vec_fun_pattern.cpp
)
ADD_LIBRARY(cppad_ipopt ${source_list})
set_compile_flags( cppad_ipopt "${cppad_debug_which}" "${source_list}" )

# install(FILES files... DESTINATION <dir>
#   [PERMISSIONS permissions...]
#   [CONFIGURATIONS [Debug|Release|...]]
#   [COMPONENT <component>]
#   [RENAME <name>] [OPTIONAL])
INSTALL(FILES cppad_ipopt_nlp.hpp DESTINATION ${cppad_abs_includedir})

# install(TARGETS myExe mySharedLib myStaticLib
#   RUNTIME DESTINATION bin
#   LIBRARY DESTINATION lib
#   ARCHIVE DESTINATION lib/static)
INSTALL(TARGETS cppad_ipopt DESTINATION ${cppad_abs_libdir})

=== example/abs_normal/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the example/print_for directory tests
#
SET(source_list
    abs_eval.cpp
    abs_min_linear.cpp
    abs_min_quad.cpp
    abs_normal.cpp
    get_started.cpp
    lp_box.cpp
    min_nso_linear.cpp
    min_nso_quad.cpp
    qp_box.cpp
    qp_interior.cpp
    simplex_method.cpp
)
#
set_compile_flags( example_abs_normal "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_abs_normal EXCLUDE_FROM_ALL ${source_list})

# check_example_abs_normal target
ADD_CUSTOM_TARGET(check_example_abs_normal
    example_abs_normal
    DEPENDS
    example_abs_normal
)
MESSAGE(STATUS "make check_example_abs_normal: available")

# Change check_example_depends in parent environment
add_to_list(check_example_depends check_example_abs_normal)
SET(check_example_depends "${check_example_depends}" PARENT_SCOPE)

=== example/general/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the example/general directory tests
#
# adolc_sources, adolc_libs
IF( cppad_has_adolc )
    SET(adolc_sources mul_level_adolc.cpp mul_level_adolc_ode.cpp)
    SET(adolc_libs adolc)
ELSE( cppad_has_adolc )
    SET(adolc_sources "")
    SET(adolc_libs "")
ENDIF( cppad_has_adolc )
#
# eigen_sources
IF( cppad_has_eigen )
    SET(eigen_sources eigen_det.cpp eigen_array.cpp)
ELSE( cppad_has_eigen )
    SET(eigen_sources "")
ENDIF( cppad_has_eigen )
#
SET(source_list
    general.cpp
    ${adolc_sources}
    ${eigen_sources}
    abort_recording.cpp
    fabs.cpp
    acos.cpp
    acosh.cpp
    ad_assign.cpp
    ad_ctor.cpp
    add.cpp
    add_eq.cpp
    ad_fun.cpp
    ad_in_c.cpp
    ad_input.cpp
    ad_output.cpp
    asin.cpp
    asinh.cpp
    atan2.cpp
    atan.cpp
    atanh.cpp
    azmul.cpp
    base_alloc.hpp
    base2ad.cpp
    base_require.cpp
    bender_quad.cpp
    bool_fun.cpp
    capacity_order.cpp
    change_param.cpp
    check_for_nan.cpp
    compare_change.cpp
    compare.cpp
    complex_poly.cpp
    cond_exp.cpp
    cos.cpp
    cosh.cpp
    div.cpp
    div_eq.cpp
    equal_op_seq.cpp
    erf.cpp
    exp.cpp
    expm1.cpp
    for_one.cpp
    for_two.cpp
    forward.cpp
    forward_dir.cpp
    forward_order.cpp
    fun_assign.cpp
    fun_check.cpp
    hes_lagrangian.cpp
    hes_lu_det.cpp
    hes_minor_det.cpp
    hessian.cpp
    hes_times_dir.cpp
    independent.cpp
    integer.cpp
    interface2c.cpp
    interp_onetape.cpp
    interp_retape.cpp
    jac_lu_det.cpp
    jac_minor_det.cpp
    jacobian.cpp
    log10.cpp
    log1p.cpp
    log.cpp
    lu_ratio.cpp
    lu_vec_ad.cpp
    lu_vec_ad.hpp
    lu_vec_ad_ok.cpp
    mul.cpp
    mul_eq.cpp
    mul_level.cpp
    mul_level_ode.cpp
    near_equal_ext.cpp
    new_dynamic.cpp
    number_skip.cpp
    numeric_type.cpp
    num_limits.cpp
    ode_stiff.cpp
    taylor_ode.cpp
    opt_val_hes.cpp
    con_dyn_var.cpp
    poly.cpp
    pow.cpp
    pow_int.cpp
    print_for.cpp
    reverse_checkpoint.cpp
    reverse_one.cpp
    reverse_three.cpp
    reverse_two.cpp
    rev_one.cpp
    rev_two.cpp
    rosen_34.cpp
    runge45_2.cpp
    seq_property.cpp
    sign.cpp
    sin.cpp
    sinh.cpp
    sqrt.cpp
    stack_machine.cpp
    sub.cpp
    sub_eq.cpp
    tan.cpp
    tanh.cpp
    tape_index.cpp
    unary_minus.cpp
    unary_plus.cpp
    value.cpp
    var2par.cpp
    vec_ad.cpp
)
set_compile_flags( example_general "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_general EXCLUDE_FROM_ALL ${source_list})
#
# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_general
    ${adolc_libs}
)
#
# Add the check_example_general target
ADD_CUSTOM_TARGET(check_example_general
    example_general
    DEPENDS example_general
)
MESSAGE(STATUS "make check_example_general: available")
#
# add to check check_example_depends in parent environment
add_to_list(check_example_depends check_example_general)
SET(check_example_depends "${check_example_depends}" PARENT_SCOPE)

=== speed/sacado/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the speed/sacado directory tests
# Inherit build type from ../CMakeList.txt

# assert sacado_prefix is defined
IF ( NOT sacado_prefix )
    MESSAGE(FATAL_ERROR
        "speed/sacado/CMakeLists.txt: sacado_prefix = ${sacado_prefix}"
    )
ENDIF ( NOT sacado_prefix )

# Adds flags to the compiler command line for sources in the current directory
# and below. This command can be used to add any flags, but it was originally
# intended to add preprocessor definitions.
ADD_DEFINITIONS("-DCPPAD_SACADO_SPEED -DRAD_AUTO_AD_Const")

# Local include directories to search (not in package_prefix/includdir)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
SET(source_list ../main.cpp
    det_lu.cpp
    det_minor.cpp
    mat_mul.cpp
    ode.cpp
    poly.cpp
    sparse_hessian.cpp
    sparse_jacobian.cpp
)
set_compile_flags( speed_sacado "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( speed_sacado EXCLUDE_FROM_ALL ${source_list} )

# determine libraries necessary to link Sacado
SET(config_file "${sacado_prefix}/include/Makefile.export.Sacado")
IF(NOT EXISTS ${config_file})
    MESSAGE(FATAL_ERROR
"the file sacado_prefix/include/Makefile.export.Sacado does not exist
where sacado_prefix=${sacado_prefix}"
    )
ENDIF(NOT EXISTS ${config_file})
SET(cmd "grep" "Sacado_LIBRARIES=" "${config_file}")
EXECUTE_PROCESS(
    COMMAND         ${cmd}
    OUTPUT_VARIABLE temp1
)
STRING(REGEX REPLACE "Sacado_LIBRARIES= *-l" "" temp2  ${temp1})
STRING(STRIP ${temp2} temp3)
STRING(REGEX REPLACE " *-l" ";" sacado_lib_list ${temp3})
#
# include the dl library if it is in the system path
CHECK_LIBRARY_EXISTS( dl dlopen "${CMAKE_SYSTEM_LIBRARY_PATH}" dl_found )
IF( dl_found )
    TARGET_LINK_LIBRARIES(speed_sacado speed_src ${sacado_lib_list} dl)
ELSE( dl_found )
    TARGET_LINK_LIBRARIES(speed_sacado speed_src ${sacado_lib_list})
ENDIF( dl_found )
#
# Add the check_speed_sacado target
ADD_CUSTOM_TARGET(check_speed_sacado
    speed_sacado correct 54321
    DEPENDS speed_sacado speed_src
)
MESSAGE(STATUS "make check_speed_sacado: available")

# Change check depends in parent environment
add_to_list(check_speed_depends check_speed_sacado)
SET(check_speed_depends "${check_speed_depends}" PARENT_SCOPE)

=== test_more/cppad_for_tmb/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
#
# Name for this text
SET(name cppad_for_tmb)
#
# Add extra compiler flags to cppad_cxx_flags so set_compile_flags uses them.
# This change only affects the cppad_for_tmb tests (NO PARENT_SCOPE).
SET(cppad_cxx_flags "${cppad_cxx_flags} ${OpenMP_CXX_FLAGS} -DCPPAD_FOR_TMB")
#
SET(source_list
    ${name}.cpp
    implicit_ctor.cpp
    perfer_reverse.cpp
    multi_atomic.cpp
    multi_checkpoint.cpp
)
set_compile_flags(
    test_more_${name} "${cppad_debug_which}" "${source_list}"
)
#
# now that we have the properties, add the executable
ADD_EXECUTABLE( test_more_${name} EXCLUDE_FROM_ALL ${source_list} )
#
# Extra flags used by linker for openmp support
SET(CMAKE_EXE_LINKER_FLAGS ${OpenMP_CXX_FLAGS} )
#
# check_test_more_${name} target
ADD_CUSTOM_TARGET(
    check_test_more_${name} test_more_${name} DEPENDS test_more_${name}
)
MESSAGE(STATUS "make check_test_more_${name}: available")

# Add check_test_more_${name} to check depends in parent environment
add_to_list(check_test_more_depends check_test_more_${name})
SET(check_test_more_depends "${check_test_more_depends}" PARENT_SCOPE)

=== test_more/general/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the test_more/general tests
#
# adolc_sources, adolc_libs
IF( cppad_has_adolc )
    SET(adolc_sources base_adolc.cpp)
    SET(adolc_libs adolc)
ELSE( cppad_has_adolc )
    SET(adolc_sources "")
    SET(adolc_libs "")
ENDIF( cppad_has_adolc )
#
# eigen_sources
IF( cppad_has_eigen )
    SET(eigen_sources cppad_eigen.cpp eigen_mat_inv.cpp)
ELSE( cppad_has_eigen )
    SET(eigen_sources "")
ENDIF( cppad_has_eigen )
#
# ipopt_prefix
IF( cppad_has_ipopt )
    SET(ipopt_sources ipopt_solve.cpp)
    SET(ipopt_libs "${ipopt_LIBRARIES}")
ELSE( cppad_has_ipopt )
    SET(ipopt_sources "")
    SET(ipopt_libs "")
ENDIF( cppad_has_ipopt )
#
# BEGIN_SORT_THIS_LINE_PLUS_6
SET(source_list
    ${adolc_sources}
    ${eigen_sources}
    ${ipopt_sources}
    general.cpp
    acos.cpp
    acosh.cpp
    add.cpp
    add_eq.cpp
    add_zero.cpp
    adfun_copy.cpp
    asin.cpp
    asinh.cpp
    assign.cpp
    atan2.cpp
    atan.cpp
    atanh.cpp
    atomic_three.cpp
    azmul.cpp
    base_alloc.cpp
    bool_sparsity.cpp
    chkpoint_one.cpp
    chkpoint_two.cpp
    check_simple_vector.cpp
    compare_change.cpp
    compare.cpp
    cond_exp_ad.cpp
    cond_exp.cpp
    cond_exp_rev.cpp
    copy.cpp
    cos.cpp
    cosh.cpp
    dbl_epsilon.cpp
    dependency.cpp
    div.cpp
    div_eq.cpp
    div_zero_one.cpp
    erf.cpp
    exp.cpp
    expm1.cpp
    extern_value.cpp
    fabs.cpp
    for_hess.cpp
    for_sparse_hes.cpp
    for_sparse_jac.cpp
    forward.cpp
    forward_dir.cpp
    forward_order.cpp
    from_base.cpp
    fun_check.cpp
    hes_sparsity.cpp
    jacobian.cpp
    local/vector_set.cpp
    log10.cpp
    log1p.cpp
    log.cpp
    mul_cond_rev.cpp
    mul.cpp
    mul_cskip.cpp
    mul_eq.cpp
    mul_level.cpp
    mul_zdouble.cpp
    mul_zero_one.cpp
    near_equal_ext.cpp
    neg.cpp
    new_dynamic.cpp
    num_limits.cpp
    ode_err_control.cpp
    optimize.cpp
    parameter.cpp
    poly.cpp
    pow.cpp
    pow_int.cpp
    print_for.cpp
    reverse.cpp
    rev_sparse_jac.cpp
    rev_two.cpp
    romberg_one.cpp
    rosen_34.cpp
    runge_45.cpp
    simple_vector.cpp
    sin_cos.cpp
    sin.cpp
    sinh.cpp
    sparse_hessian.cpp
    sparse_jacobian.cpp
    sparse_jac_work.cpp
    sparse_sub_hes.cpp
    sparse_vec_ad.cpp
    sqrt.cpp
    std_math.cpp
    sub.cpp
    sub_eq.cpp
    subgraph.cpp
    sub_zero.cpp
    tan.cpp
    test_vector.cpp
    to_string.cpp
    value.cpp
    vec_ad.cpp
    vec_ad_par.cpp
    vec_unary.cpp
)
# END_SORT_THIS_LINE_MINUS_2
set_compile_flags( test_more_general "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(test_more_general EXCLUDE_FROM_ALL ${source_list})
#
# must first build cppad_lib
STRING(COMPARE EQUAL "${cppad_lib}" "" empty_cppad_lib )
IF( NOT  empty_cppad_lib )
    ADD_DEPENDENCIES(test_more_general ${cppad_lib} )
ENDIF( NOT  empty_cppad_lib )
#
# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(test_more_general
    ${cppad_lib}
    ${adolc_libs}
    ${ipopt_libs}
    ${colpack_libs}
)
#
# Add the check_test_more_general target
ADD_CUSTOM_TARGET(check_test_more_general
    test_more_general
    DEPENDS
    test_more_general
)
MESSAGE(STATUS "make check_test_more_general: available")
#
# Change check depends in parent environment
add_to_list(check_test_more_depends check_test_more_general)
SET(check_test_more_depends "${check_test_more_depends}" PARENT_SCOPE)

=== example/multi_thread/openmp/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the example/multi_thread/openmp directory tests
# Inherit build type from ../CMakeList.txt

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/.. )

# Cannot find specifications for CMAKE_CXX_FLAGS in version 2.6 documentation
# so using ADD_DEFINITIONS instead.
ADD_DEFINITIONS( ${OpenMP_CXX_FLAGS} )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
SET(source_list ../thread_test.cpp
    ${CMAKE_SOURCE_DIR}/speed/src/microsoft_timer.cpp
    ../team_example.cpp
    ../harmonic.cpp
    ../multi_atomic.cpp
    ../multi_checkpoint.cpp
    ../multi_newton.cpp
    a11c_openmp.cpp
    simple_ad_openmp.cpp
    team_openmp.cpp
)
set_compile_flags( example_multi_thread_openmp "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( example_multi_thread_openmp EXCLUDE_FROM_ALL ${source_list} )

# Extra flags used by linker for openmp support
SET(CMAKE_EXE_LINKER_FLAGS ${OpenMP_CXX_FLAGS} )

# Add the check_example_multi_thread_openmp target
ADD_CUSTOM_TARGET(check_example_multi_thread_openmp
    example_multi_thread_openmp simple_ad
    DEPENDS example_multi_thread_openmp
)
MESSAGE(STATUS "make check_example_multi_thread_openmp: available")


# Change check depends in parent environment
add_to_list(check_example_multi_thread_depends check_example_multi_thread_openmp)
SET(check_example_multi_thread_depends "${check_example_multi_thread_depends}" PARENT_SCOPE)

=== debian/changelog ===
cppad (2019.02.00.1-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 23 Feb 2019 18:02:03 +0000

=== debian/control ===
Source: cppad
Section: devel
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Miles Lubin <miles.lubin@gmail.com>,
           Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper (>= 11), cmake, libboost-dev
Standards-Version: 4.3.0
Homepage: https://projects.coin-or.org/CppAD/
Vcs-Git: https://salsa.debian.org/science-team/cppad.git
Vcs-Browser: https://salsa.debian.org/science-team/cppad

Package: cppad
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Automatic Differentiation (AD) of C++ algorithms
 CppAD is a package for automatic differentiation of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains C++ header files and documentation.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

# override_dh_autoreconf:
# 	@echo "Hey debhelper, what are you doing?"
# 	@echo "THE BUILD SYSTEM IS CMAKE!!!"
# 	@echo "But maybe you do not care, maybe you just like to watch the world burn."
# 	dh_autoreconf

override_dh_auto_install:
	dh_auto_install
	@echo "File cppad.pc should be installed only once, in the right place."
	@echo "See lintian-info -t pkg-config-unavailable-for-cross-compilation"
	if [ -e debian/cppad/usr/share/pkgconfig/cppad.pc \
	     -a -e debian/cppad/usr/lib/pkgconfig/cppad.pc ]; then \
	  rm --verbose debian/cppad/usr/lib/pkgconfig/cppad.pc; \
	  rmdir --ignore-fail-on-non-empty --verbose debian/cppad/usr/lib/pkgconfig; \
	  rmdir --ignore-fail-on-non-empty --verbose debian/cppad/usr/lib; \
	fi;

## cppad 2019.02.00.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 endif()
 #
 # cppad_version is used by version.sh to get the version number.
-SET(cppad_version "20190200.1")
+SET(cppad_version "20190200.2")
 SET(cppad_url          "http://www.coin-or.org/CppAD" )
 SET(cppad_description  "Differentiation of C++ Algorithms" )
 #

=== debian/changelog ===
cppad (2019.02.00.2-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 29 Apr 2019 15:43:13 +0100

## cppad 2019.02.00.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # -----------------------------------------------------------------------------
-# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
+# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-19 Bradley M. Bell
 #
 # CppAD is distributed under the terms of the
 #              Eclipse Public License Version 2.0.
@@ -25,7 +25,7 @@
 endif()
 #
 # cppad_version is used by version.sh to get the version number.
-SET(cppad_version "20190200.2")
+SET(cppad_version "20190200.3")
 SET(cppad_url          "http://www.coin-or.org/CppAD" )
 SET(cppad_description  "Differentiation of C++ Algorithms" )
 #

=== debian/changelog ===
cppad (2019.02.00.3-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 05 Jun 2019 20:52:08 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Miles Lubin <miles.lubin@gmail.com>,
            Barak A. Pearlmutter <bap@debian.org>
-Build-Depends: debhelper (>= 11), cmake, libboost-dev
+Build-Depends: debhelper-compat (= 12), cmake, libboost-dev
 Standards-Version: 4.3.0
 Homepage: https://projects.coin-or.org/CppAD/
 Vcs-Git: https://salsa.debian.org/science-team/cppad.git

## cppad 2019.02.00.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 endif()
 #
 # cppad_version is used by version.sh to get the version number.
-SET(cppad_version "20190200.3")
+SET(cppad_version "20190200.4")
 SET(cppad_url          "http://www.coin-or.org/CppAD" )
 SET(cppad_description  "Differentiation of C++ Algorithms" )
 #

=== debian/changelog ===
cppad (2019.02.00.4-1) unstable; urgency=medium

  * New upstream release
  * Bump policy

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 09 Aug 2019 13:16:13 +0200
